.nolist				;defines, includes, and equates
#DEFINE equ .equ
#DEFINE EQU .equ
#DEFINE end .end
#include "dcs6brass.inc"		;ROM call definitions
.list
	.org progstart
#IFDEF TI83P
	.db $BB,$6D
#ENDIF
	xor d
#IFDEF TI83P
	.db $C9
#ENDIF
	jr Start
	.dw 0
	.db $05,$00
	.dw Icon
	.dw 0
Start:
	call OpenGUIStack
	ld hl,SmWinData
	ld de,SmWinDataEnd-SmWinData
	ld a,GUIRSmallWin
	call PushGUIStack
	ld hl,WGetPwd1
	ld de,WGetPwd1End-WGetPwd1
	ld a,GUIRPassIn
	call PushGUIStack
	ld hl,WGetPwd2
	ld de,WGetPwd2End-WGetPwd2
	ld a,GUIRPassIn
	call PushGUIStack
	ld hl,SmWinButtons
	ld de,SmWinButtonsEnd-SmWinButtons
	ld a,GUIRWinButtons
	call PushGUIStack
	ld hl,Pwd1Txt
	ld de,Pwd1TxtEnd-Pwd1Txt
	ld a,GUIRText
	call PushGUIStack
	ld hl,Pwd2Txt
	ld de,Pwd2TxtEnd-Pwd2Txt
	ld a,GUIRText
	call PushGUIStack
	ld hl,CancelButton
	ld de,CancelButtonEnd-CancelButton
	ld a,GUIRButtonText
	call PushGUIStack
	ld hl,OKButton
	ld de,OKButtonEnd-OKButton
	ld a,GUIRButtonText
	call PushGUIStack
	ld hl,0
	call GUIMouse
;	ret

ProcessPwds:
	;compare passwords now
	call ResetAppPage
	call GUIFindFirst
	push hl
		call GUIFindNext
		ld de,10
		add hl,de
		push hl
		ld b,0
CpCountLoop:
			ld a,(hl)
			or a
			jr z,CpCountDone
			inc b
			inc hl
			ld a,b
			cp 8
			jr nz,CpCountLoop
CpCountDone:
			pop hl
		ex de,hl
		pop hl
	push bc					;save b
		push de
			ld de,10
			add hl,de
			;ld a,(hl)
			push hl
			ld b,0
CpCountLoop2:
				ld a,(hl)
				or a
				jr z,CpCountDone2
				inc b
				inc hl
				ld a,b
				cp 8
				jr nz,CpCountLoop2
CpCountDone2:
				pop hl
			pop de
		ld a,b
		pop bc
	push hl
		ld c,a
		cp b
		jr nz,NoGood
CpLoop:
		ld a,(de)
		cp (hl)
		jr nz,NoGood
		inc hl
		inc de
		djnz CpLoop
		pop hl
	ld de,Password
	ld bc,8
	ldir					;copy the password in
	ld hl,SEText
	rst 20h
	bcall(_chkfindsym)
	ret nc
	ld hl,EndSEData-StartSEData
	push hl
	bcall(_createprotprog)
	inc de
	inc de
	ld hl,StartSEData
	pop bc
	ldir
	jr NormalExit
NoGood:
		pop hl			;restore the save location
	ld a,44
	ld (PENROW),a
	ld a,10
	ld (PENCOL),a
	ld hl,Mismatch
	bcall(_vputs)
	call ResetAppPage
	call Pause
	jr NormalExit
exitMyProg:
	call ResetAppPage
NormalExit:
	call CloseGUIStack
	ret

StartSEData:
	.db $BB,$6D
	.db $AB
#IFDEF TI83P
	.db $C9
#ENDIF
SEStart:
	.db $31
	.db $87
	.db $50
	.dw SELoad-SEStart
	.dw 0
	.dw 0
SELoad:
	ld (ix),0
	push ix
	bcall(_grbufclr)
	call OpenGUIStack
	ld hl,SESmWinData-SELoad+seram
	ld de,SESmWinDataEnd-SESmWinData
	ld a,GUIRSmallWin
	call PushGUIStack
	ld hl,SEWGetPwd1-SELoad+seram
	ld de,SEWGetPwd1End-SEWGetPwd1
	ld a,GUIRPassIn
	call PushGUIStack
	ld hl,SEPwd1Txt-SELoad+seram
	ld de,SEPwd1TxtEnd-SEPwd1Txt
	ld a,GUIRText
	call PushGUIStack
	ld hl,SEOKButton-SELoad+seram
	ld de,SEOKButtonEnd-SEOKButton
	ld a,GUIRButtonText
	call PushGUIStack
	ld hl,0
	call GUIMouse
	ret

SEProcessPwd:
		call ResetAppPage
		call GUIFindFirst
		ld de,10
		add hl,de
		ld de,Password-SELoad+seram
CpLoop2:
		ld a,(de)
		or a
		jr z,CpLoopDone
		cp (hl)
		jr nz,NoGood2
		inc de
		inc hl
		djnz CpLoop2
CpLoopDone:
		call CloseGUIStack
		pop ix
	ld (ix),0
	ret
NoGood2:
		ld hl,SEIncorrect-SELoad+seram
		ld de,SEIncorrectEnd-SEIncorrect
		ld a,GUIRText
		call PushGUIStack
		call RenderGUI
		call Pause
		call CloseGUIStack
		pop ix
	ld (ix),1
	bjump(_JForceCmdNoChar)
SEIncorrect:
	.db 3,23,0,"Incorrect!",0
SEIncorrectEnd:
TempData:
	.db 0,0,0,0,0,0,0,0
Password:
	.db 0,0,0,0,0,0,0,0
SESmWinData:
     .db 5,5     ;the x and y coordinates relative to the LCD of the top-left of the window
     .db $20,$50,$70,$70,$70   ;a square icon
     .db "Enter Password",0    ;the window title
SESmWinDataEnd:
SEPwd1Txt:
	.db 3,9,0,"Enter your password:",0
SEPwd1TxtEnd:
SEWGetPwd1:
	.db 15,16,40
	.dw 8
	.dw 0
	.db 0
SEWGetPwd1End:
SEOKButton:
	.db 8,31
	.dw SEProcessPwd-SELoad+seram
	.db "OK",0
SEOKButtonEnd:
SELoadEnd:
EndSEData:

SEText:
	.db 5,$23,"PW",0
MisMatch:
	.db "Mismatch!",0
Icon:
	.db $1C,$CC,$3F,$26,$47,$16,$B3,$16
	.db $B3,$16,$83,$97,$41,$FF,$3C,$EB
	.db $0C,$7B,$0B,$3B,$0B,$3B,$0A,$EB
	.db $0A,$AB,$0A,$AB,$0A,$AB,$0F,$FE
SmWinData:
     .db 5,5     ;the x and y coordinates relative to the LCD of the top-left of the window
     .db $20,$50,$70,$70,$70   ;a square icon
     .db "Set Up Password",0    ;the window title
SmWinDataEnd:
SmWinButtons:
	.db 00100000b      ;only displaying a close button
	.dw 0              ;null pointer
	.dw 0              ;another null pointer
	.dw exitMyProg     ;we'll jump to exitMyProg when this button is clicked
SmWinButtonsEnd:
Pwd1Txt:
	.db 1,1,0,"Enter password:",0
Pwd1TxtEnd:
Pwd2Txt:
	.db 1,15,0,"Reenter password:",0
Pwd2TxtEnd:
WGetPwd1:
	.db 1,8,40
	.dw 8
	.dw 0
	.db 0
WGetPwd1End:
WGetPwd2:
	.db 1,22,40
	.dw 8
	.dw 0
	.db 0
WGetPwd2End:
CancelButton:
	.db 28,31
	.dw exitMyProg
	.db "Cancel",0
CancelButtonEnd:
OKButton:
	.db 8,31
	.dw ProcessPwds
	.db "OK",0
OKButtonEnd:
.end
END